#include "MPC5643L.h"




#define FCCU_CFK_KEY 	0x618B7A50
#define FCCU_NCFK_KEY 	0xAB3498FE
extern void clear_CF(void);
extern void clear_NCF(void);
extern void DisableSoftwareWatchdog(void);

void InitializeModesAndClock(void) {
	if (ME.GS.B.S_CURRENT_MODE == 2) {
		clear_CF();
		clear_NCF();

		RGM.FES.R = 0xFFFF;     // Clear the FES
		RGM.FBRE.B.BE_SOFT_FUNC = 0; // RESET_B is asserted on a software 'functional' reset event.
		ME.MCTL.R = 0x00005AF0; // Change the mode to "reset" & Key
		ME.MCTL.R = 0x0000A50F; // Change the mode to "reset" & Key   	
  }
  
	ME.MER.R = 0x000025FF; // Enble all mode in mode entry MODE_ENABLE REGISTER

	ME.RUN[0].R = 0x001F0010;      //  Configure RUN 0 mode Optional
	ME.MCTL.R   = 0x40005AF0;      //  go to run 0 mode OPTIONAL
	ME.MCTL.R   = 0x4000A50F;      //  go to run 0 mode optional
	while(ME.GS.B.S_MTRANS==1){}      //  Wait for mode entry to complete
	while(ME.GS.B.S_CURRENT_MODE!=4){} //  Check RUN0 mode has been entered
}


void DisableSoftwareWatchdog (void) {
	// remove the SWT Soft lock
	SWT.SR.R = 0x0000C520;
	SWT.SR.R = 0x0000D928;
	// disable SWT
	SWT.CR.B.WEN = 0x0;
}

void clear_CF(void) {
	uint32_t i,a[4];
  
	for(i=0;i<4;i++) {
		FCCU.CFK.R = FCCU_CFK_KEY;
		FCCU.CF_S[i].R = 0xFFFFFFFF;

		while(FCCU.CTRL.B.OPS != 0x3){}           /* wait for the completion of the operation */
		a[i]=FCCU.CF_S[i].R;
	}
}

void clear_NCF(void) {
	uint32_t i,b[4];

	for(i=0;i<4;i++){
		FCCU.NCFK.R = FCCU_NCFK_KEY;
		FCCU.NCF_S[i].R = 0xFFFFFFFF;

		while(FCCU.CTRL.B.OPS != 0x3){}           /* wait for the completion of the operation */
		b[i]=FCCU.NCF_S[i].R;
	}
}
/*************************************************************************************************************************/                    	
int main(void) 
{
	unsigned long u32Counter;
	
	DisableSoftwareWatchdog();
	InitializeModesAndClock();


	/* Output pins */
	SIU.PCR[54].R = 0x0200;		// D4 green
	SIU.PCR[107].R = 0x0200; 	// D4 Red	
	SIU.PCR[106].R = 0x0200; 	// D1	
	SIU.PCR[83].R = 0x0200; 	// D2


	SIU.PCR[51].R = 0x0200; 	// GPIO51
	SIU.PCR[18].R = 0x0200; 	// LIN0_TXD
	SIU.PCR[16].R = 0x0200; 	// FLEXCAN0_TXD
	

	/* Input pins */
	SIU.PCR[12].R = 0x0100; 	// SW1 (DSPI2_SOUT)
	SIU.PCR[13].R = 0x0100; 	// SW2 (DSPI2_SIN)
	

	SIU.GPDO[107].R = SIU.GPDO[107].R ^ 0x01; 	// D4 red


  /* Loop forever */
  	for (;;) 
  	{
		u32Counter++;
		
		SIU.GPDO[106].R = SIU.GPDI[12].R; 	// turn on LED1 when SW1 is pressed
		SIU.GPDO[83].R = SIU.GPDI[13].R; 	// turn on LED2 when SW2 is pressed
		SIU.GPDO[51].R = 0x01; 				// GPIO51 high level

		SIU.GPDO[18].R = SIU.GPDO[18].R ^ 0x01; // LIN0_TXD toogle
		SIU.GPDO[16].R = SIU.GPDO[16].R ^ 0x01; // FLEXCAN0_TXD toogle

		if(u32Counter==0x7FFFF)
		{
			SIU.GPDO[54].R = SIU.GPDO[54].R ^ 0x01; 	// D4 green
			SIU.GPDO[107].R = SIU.GPDO[107].R ^ 0x01; 	// D4 red
			u32Counter=0;
		}
  }
}



